package ija.classLoading;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;

public class MyClassLoader extends ClassLoader {

   private String mDirectory;

   public MyClassLoader(String pDirectory) {
       super();
       mDirectory = pDirectory;
   }

   protected Class findClass( String pClassName ) throws ClassNotFoundException {
       try {
           System.out.println( "Current dir: " + new File( mDirectory ).getAbsolutePath() + "; class name: " + pClassName);
           File lClassFile = new File( mDirectory, pClassName + ".class" );
           InputStream lInput = new BufferedInputStream( new FileInputStream( lClassFile ) );
           ByteArrayOutputStream lOutput = new ByteArrayOutputStream();
           int i = 0;
           while( ( i = lInput.read() ) >= 0 ) {
               lOutput.write( i );
           }
           byte[] lBytes = lOutput.toByteArray();
           return defineClass( pClassName, lBytes, 0, lBytes.length );
       } catch( Exception e ) {
           throw new ClassNotFoundException( "Class: " + pClassName + " could not be found" );
       }
   }
}
